#include <stdio.h>
#include <stdlib.h> 
int main(int argc, char *argv[]) {
    int        dlzka = 0; // dlzka suboru
    int        nuly = 0; // pocet nul
    int        jednotky = 0; // pocet jednotiek
    int        ch; // aktualny znak
    int        dl_pak = 0; // dlzka paketu
    int        poc_pak = 0; // pocet paketov danej dlzky
    int        z_pak = 0; // pocet chybnych paketov
    int        c_pak = 0; // indikator koruptneho paketu
    int        poc_str_pak = 0; // pocet stratenych paketov
    int        poc_ch_v_pak = 0; // pocet chyb v pakete
    FILE    *in_file = fopen(argv[1], "r"); // pointer na subor

    if (in_file == NULL) { // checkne ci existuje subor
        printf("Nejde otvorit! %s\n", argv[1]);
        exit(8);
    }
    
    dl_pak = atoi(argv[2]); // nacitanie argumentu dlzky paketov

    while (1) {
        ch = fgetc(in_file); // zober znak zo suboru
        if (ch == EOF) // ked konec tak astalavistababy
            break; // adios
        else
            if (ch == 49) {
                ++jednotky; // ked jednotka tak pridaj
                ++poc_ch_v_pak;
            }
            if (ch == 48) ++nuly; // ked nula tak pridaj
            if ((((jednotky + nuly) % (dl_pak)) == 0) && (poc_ch_v_pak == dl_pak)) ++poc_str_pak; // ked novy paket a same jednotky, potom je to strateny paket
            if (((jednotky + nuly) % (dl_pak)) == 0) poc_ch_v_pak = 0; // resetuje pocet chyb v pakete
            if (((jednotky + nuly - 1) % (dl_pak)) == 0) c_pak=0; // resetuje indikator ked je dalsi paket     
            if ((ch == 49) && (c_pak == 0)) { // ak mame chybu(ch==49) a este dobry paket 
                ++z_pak; // potom inkrementuje pocet koruptnych paketov
                c_pak=1; // a nastavi indikator
            }
    }

    dlzka = jednotky + nuly; // dlzka je nuly+jednotky
    poc_pak = dlzka/dl_pak; // pocet paketov je dlzka/dlzka paketu(URCITE JE TO CELE CISLO, TAK BOLO ZADANIE)
    printf("\nWEISS (C) 2010\n");
    printf("\nPocet vsetkych charakterov je \t%d\nPocet chyb je \t\t\t%d\nPocet blokov je \t\t%d\nP(bit) je \t\t\t%.8f%\nP(blok) je \t\t\t%.8f%\n\nSTATISTIKA BEZ STRATENYCH BLOKOV\n\nPocet stratenych blokov je \t%d\nPocet vsetkych charakterov je \t%d\nPocet chyb je \t\t\t%d\nP(bit) je \t\t\t%.8f%\nP(blok) je \t\t\t%.8f%\n\n",
            dlzka, jednotky, poc_pak, (float)jednotky/dlzka, (float)z_pak/poc_pak, poc_str_pak, dlzka-poc_str_pak*dl_pak, jednotky-poc_str_pak*dl_pak, (float)(jednotky-poc_str_pak*dl_pak)/(dlzka-poc_str_pak*dl_pak), (float)(z_pak-poc_str_pak)/(poc_pak-poc_str_pak));

    fclose(in_file); // zatvori
    return (0);
}
